// =========================================================
// ECE 4760: Final Project (Fall 2018)
// Professor Bruce Land
// Authors:
//              Stewart Aslan(saa243) 
//          Thinesiya Krishnathasan(tk455) 
//                Yijia Chen(yc2366)
//
// IMU: Desmond Caulley, Nadav Nehoran, Sherry Zhao
// nRF24: Douglas Katz, Fred Kummer
// =========================================================

#include "config.h"
#include <stdio.h>
#define	SYS_FREQ 40000000 // change the frequency of the clock
#include "nrf24l01.h"
#define spi_divider 10

#include "config_1_2_2a.h"
#include "pt_cornell_1_2_2a.h"
#include "i2c_helper.h"

static struct pt pt_TX;

static int key_start = 1;
static int width; // iwdth of the received packet 
static int start_sig = 0;


//The actual period of the wave
int generate_period = 5000;
static int pwm_low_time = 2500;
int pwm_on_time = 2000;

float values[7] = {0, 0, 0, 0, 0, 0, 0};
static float yAccel = 0;
static float zAccel = 0;
static float xAccel = 0;
static float temp = 0;
static float xGyro = 0;
static float yGyro = 0;
static float zGyro = 0;
static float x_offset = 0;
static float y_offset = 0;
static float ax_g = 0;
static float ay_g = 0;
static float az_g = 0;
static float xGyro_1; // offset
static float yGyro_1;
static float xGyro_2;
static float yGyro_2;
static float xGyro_last;
static float yGyro_last;
static float xAccel_1;
static float xAccel_2;
static float yAccel_1;
static float yAccel_2;
static float zAccel_1;
static float zAccel_2;
static float wx_list[5];
static float wy_list[5];
//static float angle_x_list[5];
//static float angle_y_list[5];
static int loop_counter = 0;
static int motor_switch = 1;
static int pwm_test = 2500;

static int prop_control_x = 0;
static int d_control_x = 0;
static float int_control_x = 0;
static int control_x = 0;
static int prop_control_y = 0;
static int d_control_y = 0;
static float int_control_y = 0;
static int control_y = 0;
static int Kp = 1;
static int Kd = 5;
static float Ki = 0.04;
static int setpoint = 0;
static int ramp = 1;
static int prop_control_z = 0;
static int d_control_z = 0;
static int control_z = 0;
static int Kpz = 1;
static int Kdz = 5;
static int prop_control_vx = 0;
static int prop_control_vy = 0;
static int d_control_vx = 0;
static int d_control_vy = 0;
static int control_vx = 0;
static int control_vy = 0;
static int Kpv = 1;
static int Kdv = 0;

static int pwm_xplus = 0;
static int pwm_xminus = 0;
static int pwm_yplus = 0;
static int pwm_yminus = 0;

static float angle_x = 0;
static float angle_x_last = 0;
static float angle_y = 0;
static float angle_y_last = 0;
static float vz = 0;
static float vz_last = 0;
static float alt = 0;
static float alt_last = 0;
static float alt_des = 0; // need to measure
static float alt_error = 0;
static float angle_des_x = 0;
static float angle_des_y = 0;
static float angle_error_x = 0;
static float angle_error_y = 0;
static float vx = 0;
static float vy = 0;
static float vx_last = 0;
static float vy_last = 0;

static int accel_total = 0;

static int flight_time = 1500;

void __ISR(_TIMER_3_VECTOR, ipl2) Timer3Handler(void) {
    // clear the timer interrupt flag
    mT3ClearIntFlag();

    if (start_sig) {

        readImuValues(values);

        // Parse the IMU data
        xGyro_last = xGyro;
        yGyro_last = yGyro;
        
        xAccel = values[0];
        yAccel = values[1];
        zAccel = values[2];
        temp = values[3];
        xGyro = values[4] - x_offset; // calibrate using offsets
        yGyro = values[5] - y_offset; // calibrate using offsets
        zGyro = values[6];

        if (xGyro != 0) {

            // PID control for lateral velocity ///////////////////////////
            
//            vx_last = vx;
//            vx = vx + xAccel * 0.02;
//            if ((vx > 0 && vx_last < 0) || (vx < 0 && vx_last > 0)) {
//                vx = 0.9*vx;
//            }
//            
//            prop_control_vx = Kpv * vx; // drive x velocity to zero
//            d_control_vx = Kdv * xAccel;
//            control_vx = prop_control_vx + d_control_vx;
//            angle_des_y = control_vx << 20;
            
            // PID control for x and y angles //////////////////////////////
            angle_x_last = angle_x;
            angle_x += xGyro*0.02;
//            if ((xGyro > 0 && xGyro_last < 0) || (xGyro < 0 && xGyro_last > 0)) {
//                angle_x = 0;
//            }
//            
            angle_y_last = angle_y;
            angle_y += yGyro*0.02;
//            if ((yGyro > 0 && yGyro_last < 0) || (yGyro < 0 && yGyro_last > 0)) {
//                angle_y = 0;
//            }
            
            // complementary filter
//            accel_total = xAccel + yAccel + zAccel;
//            if (xAccel > 0.5*ax_g && xAccel < 2*ax_g){
//            accel_total = abs(xAccel) + abs(yAccel) + abs(zAccel);
//            if (accel_total > 8192 && accel_total < 32768){
//                angle_x = 0.98*angle_x + 0.02*(atan2f(yAccel,zAccel)*180/3.14159);
//                angle_y = 0.98*angle_y + 0.02*(atan2f(xAccel,zAccel)*180/3.14159);
//            }

            angle_error_x = angle_x - angle_des_x;
            angle_error_y = angle_y - angle_des_y;
            
            prop_control_x = Kp * angle_error_x; // drive x angle to zero
            d_control_x = Kd * xGyro; // drive angular rate to zero
            int_control_x += angle_error_x;
            if ((angle_x > 0 && angle_x_last < 0) || (angle_x < 0 && angle_x_last > 0)) {
                int_control_x = 0.9*int_control_x;
            }
            control_x = prop_control_x + d_control_x + Ki * int_control_x;
            
            prop_control_y = Kp * angle_error_y; // drive x angle to zero
            d_control_y = Kd * yGyro; // drive angular rate to zero
            int_control_y += angle_error_y;
            if ((angle_y > 0 && angle_y_last < 0) || (angle_y < 0 && angle_y_last > 0)) {
                int_control_y = 0.9*int_control_y;
            }
            control_y = prop_control_y + d_control_y + Ki * int_control_y;
            
            // PID control for altitude ////////////////////////////////////
//            vz_last = vz; // velocity in z direction
//            vz = vz + zAccel * 0.02;
//            if ((vz > 0 && vz_last < 0) || (vz < 0 && vz_last > 0)) {
//                vz = 0.9*vz;
//            }
//            
//            alt_last = alt; // z position
//            alt = alt + vz * 0.02;
//            if ((alt > 0 && alt_last < 0) || (alt < 0 && alt_last > 0)) {
//                alt = 0.9*alt;
//            }
//            
//            alt_error = alt_des - alt;
//            prop_control_z = Kpz * alt_error;
//            d_control_z = Kdz * vz;
//            control_z = prop_control_z + d_control_z;
//            
//            if (control_z > 1500) {
//                control_z = 1500;
//            } else if (control_z < 0) {
//                control_z = 0;
//            }
            
//            pwm_xplus = 2500 + control_z + control_x;
//            pwm_xminus = 2500 + control_z - control_x;
//            pwm_yplus = 2500 + control_z + control_y;
//            pwm_yminus = 2500 + control_z - control_y;

            pwm_xplus = 2500 + (setpoint + control_x)*motor_switch;
            pwm_xminus = 2500 + (setpoint - control_x)*motor_switch;
            pwm_yplus = 2500 + (setpoint + control_y)*motor_switch;
            pwm_yminus = 2500 + (setpoint - control_y)*motor_switch;

            if (pwm_xplus > 4500) {
                pwm_xplus = 4500;
            } else if (pwm_xplus < 2500) {
                pwm_xplus = 2500;
            }

            if (pwm_xminus > 4500) {
                pwm_xminus = 4500;
            } else if (pwm_xminus < 2500) {
                pwm_xminus = 2500;
            }

            if (pwm_yplus > 4500) {
                pwm_yplus = 4500;
            } else if (pwm_yplus < 2500) {
                pwm_yplus = 2500;
            }

            if (pwm_yminus > 4500) {
                pwm_yminus = 4500;
            } else if (pwm_yminus < 2500) {
                pwm_yminus = 2500;
            }

            SetDCOC1PWM(pwm_xplus);
            SetDCOC2PWM(pwm_xminus);
            SetDCOC4PWM(pwm_yplus);
            SetDCOC5PWM(pwm_yminus);

            setpoint = setpoint + 3 * ramp; // ramp pulse
            
            loop_counter++;
            if (loop_counter > 500 && loop_counter < 700) {
                ramp = 0;
            } else if (loop_counter > 700 && loop_counter < flight_time) {
                ramp = -1;
            } else if (loop_counter > flight_time) {
                ramp = 0;
                motor_switch = 0;
            }
        }
    }
}




// ====================================================================
// set up the radio in transmit mode
// ====================================================================
void radioSetup_TX() {
    nrf_setup(); // initializing function

    nrf_set_arc(0x05); // 5 retransmits

    nrf_set_ard(0x00); // 250 us between retransmission

    nrf_set_rf_ch(0x01); // freq = 2.401 GHz

    nrf_en_dpl(0); // enable dynamic payloads for transmitting

    // set up addresses for autoack mode and dynamic payload length (dpl) mode
    // The tx address and the pipe 0 rx address must be the same for autoack mode
    // and dpl mode
    nrf_set_address_width(3);
    nrf_set_rx_addr(0, 0xAABBCC, 3);
    nrf_set_tx_addr(0xAABBCC);
}





// ====================================================================
// set up the radio in receive mode
// ====================================================================
void radioSetup_RX() {
    nrf_setup(); // initializing function

    nrf_set_rf_ch(0x01); // freq = 2.401 GHz

    nrf_en_dpl(1); // enable dpl for pipe 1

    // set up addresses for autoack mode and dynamic payload length (dpl) mode
    // The radio will receive on pipe 1
    nrf_set_address_width(3);
    nrf_set_rx_addr(1, 0xAABBCC, 3);
}


// ====================================================================
// Transmit the IMU data to basestation
// ====================================================================
void TX_data(){

    radioSetup_TX();

    char array[32];

    // send 1 bytes key that the radios use to syncronize on the order of the data
    sprintf(array, "%d", key_start);
    while (!nrf_send_payload(&array, 1)); 
    nrf_delay_ms(1000);

    sprintf(array, "%f", (temp / 340) + 36.53);
    while (!nrf_send_payload(&array, 32)); // send 32 bytes of data
    nrf_delay_ms(1000);

    sprintf(array, "%f", xGyro);
    while (!nrf_send_payload(&array, 32)); // send 32 bytes of data
    nrf_delay_ms(1000);

    sprintf(array, "%f", yGyro);
    while (!nrf_send_payload(&array, 32)); // send 32 bytes of data
    nrf_delay_ms(1000);

    sprintf(array, "%f", zGyro);
    while (!nrf_send_payload(&array, 32)); // send 32 bytes of data
    nrf_delay_ms(1000);
    
    sprintf(array, "%d", flight_time);
    while (!nrf_send_payload(&array, 32)); // send 32 bytes of data
    nrf_delay_ms(1000);

}




void main(void) {

    // ============= set up i2c ================================
    OpenI2C1(I2C_ON, 40);
    char data[] = {0};
    i2c_write(0x6b, data, 1); // wake up IMU from Sleep mode
    i2c_write(0x1b, data, 1);

    delay_ms(100);

    readImuValues(values);

    // Parse the IMU data
    xAccel = values[0];
    yAccel = values[1];
    zAccel = values[2];
    temp = values[3];
    xGyro = values[4];
    yGyro = values[5];
    zGyro = values[6];
    
    xGyro_1 = xGyro;
    yGyro_1 = yGyro;
    xAccel_1 = xAccel;
    yAccel_1 = yAccel;
    zAccel_1 = zAccel;

    delay_ms(50);

    readImuValues(values);

    // Parse the IMU data
    xAccel = values[0];
    yAccel = values[1];
    zAccel = values[2];
    //    temp = values[3];
    temp = 0;
    xGyro = values[4];
    yGyro = values[5];
    zGyro = values[6];

    xGyro_2 = xGyro;
    yGyro_2 = yGyro;
    xAccel_2 = xAccel;
    yAccel_2 = yAccel;
    zAccel_2 = zAccel;

    // zero the gyro values
    x_offset = (xGyro_2 + xGyro_1) / 2;
    y_offset = (yGyro_2 + yGyro_1) / 2;
    ax_g = (xAccel_2 + xAccel_1) / 2;
    ay_g = (yAccel_2 + yAccel_1) / 2;
    az_g = (zAccel_2 + zAccel_1) / 2;



    // === config the uart, DMA, vref, timer5 ISR ===========
    PT_setup();


    //240x320 vertical display
    tft_setRotation(0); // Use tft_setRotation(1) for 320x240
    

    // === Config timer and output compares to make pulses ========
    // set up timer2 to generate the wave period
    OpenTimer3(T3_ON | T3_SOURCE_INT | T3_PS_1_16, generate_period);
    ConfigIntTimer3(T3_INT_ON | T3_INT_PRIOR_2);
    mT3ClearIntFlag(); // and clear the interrupt flag

    // set up compare1 for PWM mode, X+ motor
    OpenOC1(OC_ON | OC_TIMER3_SRC | OC_PWM_FAULT_PIN_DISABLE, 0, 0); //
    // OC1 is PPS group 1, map to RPB7 (pin 16)
    PPSOutput(1, RPB7, OC1);

    // set up compare2 for PWM mode, X- motor
    OpenOC2(OC_ON | OC_TIMER3_SRC | OC_PWM_FAULT_PIN_DISABLE, 0, 0); //
    // OC2 is PPS group 2, map to RPB5 (pin 14)
    PPSOutput(2, RPB1, OC2); //B5
    //
    //    // set up compare3 for PWM mode, Y+ motor
    OpenOC4(OC_ON | OC_TIMER3_SRC | OC_PWM_FAULT_PIN_DISABLE, 0, 0); //
    // OC3 is PPS group 4, map to RPB9 (pin 18)
    PPSOutput(3, RPA2, OC4); //RA2
    ////    
    //    // set up compare3 for PWM mode, Y- motor
    OpenOC5(OC_ON | OC_TIMER3_SRC | OC_PWM_FAULT_PIN_DISABLE, 0, 0); //
    // OC3 is PPS group 4, map to RPB9 (pin 18)
    PPSOutput(3, RPB13, OC5); //RA4

    SetDCOC1PWM(2500);
    SetDCOC2PWM(2500);
    SetDCOC4PWM(2500);
    SetDCOC5PWM(2500);


    // === setup system wide interrupts  ====================
    INTEnableSystemMultiVectoredInt();


    char array[32];
    char buffer[120];

    radioSetup_RX(); // setup the radio in RX mode
    
    // ============ wait for start signal form the basestation ========================
    while (!start_sig) {

        nrf_state_rx_mode();
        if (nrf_payload_available()) { // wait for a payload to be received
            width = nrf_get_width(); // get the width of the payload

            nrf_get_payload(&array, width); // read the payload into the array

            if (width == 32) {
                start_sig = 1;
                
                // payload fo the start signal has the flight time
                flight_time = (((int)array[0] - 48)*10 + ((int)array[1] -48)) *100;

            }
        }

    }

    // ============== Start transmitting IMU data ======================================
    while (1) {

        TX_data();

    }
} // main

// === end  ======================================================