/**
 * This is a very small example that shows how to use
 * === OUTPUT COMPARE  ===
/*
 * File:        PWM example
 * Author:      Bruce Land
 * Target PIC:  PIC32MX250F128B
 */

////////////////////////////////////
// clock AND protoThreads configure!
// You MUST check this file!
//#include "config.h"
// You MUST check this file!
#include "config_1_2_2a.h"
// threading library
//#include "pt_cornell_1_2.h"
// threading library
#include "pt_cornell_1_2_2a.h"
//// graphics libraries
#include "tft_master.h"
#include "tft_gfx.h"

#include "i2c_helper.h"

// need for rand function
#include <stdlib.h>

#define IMU_READ_PERIOD 500
// string buffer
char buffer[60];

// === thread structures ============================================
// thread control structs

//print lock
static struct pt_sem print_sem ;

// note that UART input and output are threads
static struct pt pt_time, pt_input, pt_output, pt_DMA_output, pt_pid;

// system 1 second interval tick
int sys_time_seconds ;

//The actual period of the wave
int generate_period = 2000 ;
int pwm_on_time = 500 ;
static int pwm_low_time = 0;
//print state variable
int printing=0 ;

int angle_read = 0;

static PT_THREAD (protothread_pid(struct pt *pt))
{
    PT_BEGIN(pt);
      while(1) {
         
//        PT_YIELD_TIME_msec(10);
       
        float values[6]={0,0,0,0,0,0};
        // draw sys_time
        tft_fillRoundRect(0,70, 240, 14, 1, ILI9340_BLACK);// x,y,w,h,radius,color
        tft_setCursor(0, 70);
        tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(2);
        sprintf(buffer,"val= %f", values[1]);
        tft_writeString(buffer);

        // Read data from IMU in format
        // {xAccel, yAccel, zAccel, xGyro, yGyro, zGyro}
//        PT_YIELD_TIME_msec(500);
        readImuValues(values);
        
        // Parse the IMU data
        float yAccel = values[1];
        float zAccel = values[2];
        float temp  = values[3];  
        
        tft_fillRoundRect(0,90,240, 14, 1, ILI9340_BLACK);// x,y,w,h,radius,color
        tft_setCursor(0, 90);
        tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(2);
        sprintf(buffer,"yAccel= %f", yAccel);
        tft_writeString(buffer);
        
        
        tft_fillRoundRect(0,110,240, 14, 1, ILI9340_BLACK);// x,y,w,h,radius,color
        tft_setCursor(0, 110);
        tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(2);
        sprintf(buffer,"zAccel= %f", zAccel);
        tft_writeString(buffer);
        
        
        tft_fillRoundRect(0,130,240, 14, 1, ILI9340_BLACK);// x,y,w,h,radius,color
        tft_setCursor(0, 130);
        tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(2);
        sprintf(buffer,"temp= %f", (temp/340)+36.53);
        tft_writeString(buffer);
        
        
        
        PT_YIELD_TIME_msec(IMU_READ_PERIOD);

        
      } // END WHILE(1)

  PT_END(pt);
} // thread 5

// === Main  ======================================================

int main(void)
{
  // === Config timer and output compares to make pulses ========

  // === config the uart, DMA, vref, timer5 ISR ===========
  PT_setup();

  // === setup system wide interrupts  ====================
  INTEnableSystemMultiVectoredInt();
      
  // === set up i/o port pin ===============================
 // mPORTBSetPinsDigitalOut(BIT_0 );    //Set port as output

  // =============set up i2c================================
  OpenI2C1( I2C_ON, 40 );
  // init the display
  tft_init_hw();
  tft_begin();
  tft_fillScreen(ILI9340_BLACK);
  //240x320 vertical display
  tft_setRotation(0); // Use tft_setRotation(1) for 320x240

  // === now the threads ===================================
  
  // init the threads

  PT_INIT(&pt_pid);
 
   tft_fillRoundRect(0,30, 240, 14, 1, ILI9340_BLACK);// x,y,w,h,radius,color
   tft_setCursor(0, 30);
   tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(2);
   sprintf(buffer,"before ");
   tft_writeString(buffer);
  // Take the MPU 6050 out of sleep mode
  char data[] = {0};
  i2c_write(0x6b, data, 1);
  
   tft_fillRoundRect(0,50, 240, 14, 1, ILI9340_BLACK);// x,y,w,h,radius,color
   tft_setCursor(0, 50);
   tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(2);
   sprintf(buffer,"after ");
   tft_writeString(buffer);

  // Set the gyro sensitivity to 131 lsb/(degrees/second))
//  i2c_write(0x1b, data, 1);


  // schedule the threads
  while(1) {
//    PT_SCHEDULE(protothread_cmd(&pt_cmd));
//    PT_SCHEDULE(protothread_time(&pt_time));
    PT_SCHEDULE(protothread_pid(&pt_pid));
   
  }
} // main